#ifndef _memset
	#define _memset

	#if 0	' prototype/use details
		prototype memset(ptr as integer, fil as integer, cnt as integer [, typ as integer])
		' for byte use (default) 	[opt typ param value of 0]	b31:8 ignored, b7:0 hold pattern
		' for half(-word) use	 	[typ param value of 1]		b31:16 ignored, b15:0 hold pattern
		' for (full-)word use	 	[typ param value of 2]		b31:0 hold pattern
		' returns -1 on error, or a pointer to memory that was set
		#endif

	function memset(paramarray _param)

		' param #defs
		#define _memset_byte 0
		#define _memset_half 1
		#define _memset_word 2

		' param dim'g
		dim ptr, fil, cnt, typ as integer

		' validate call wrt req'd & optional params
		if (_param(15)<2 or _param(15)>3) then return -1	'return an 'error' if wrong param count on call

		ptr = _param(0)		' required param
		fil = _param(1)		' required param
		cnt = _param(2)		' required param

		' see if optional param is asserted, using it if so, ignore if not (val retained across calls)
		if _param(15)=3
			typ = _param(3)
		else
			typ = 0
			endif

		if typ < 0 or typ > 2 then return -1 	' return 'error' if 'typ' param is out of bounds

		dim iptr, i as integer
		iptr = ptr

		while cnt <> 0
			select typ
				case _memset_word
					*ptr = fil
				case _memset_half
					wr_half(ptr, fil and &HFFFF)
				case else	' _memset_byte
					wr_byte(ptr, fil and &HFF)
				endselect
			cnt -= (1 << (if(typ = _memset_half,1,0)))
			ptr += (1 << typ) 	'~
			loop

		return iptr
		endfunction
	#endif
